clang-tools 6.0.0

Public Member Functions | List of all members
clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck Class Reference

Implements C++ Core Guidelines Type.6. More...

`#include <ProTypeMemberInitCheck.h>`

Inheritance diagram for clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck:
[legend]
Collaboration diagram for clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck:
[legend]

## Public Member Functions
| ProTypeMemberInitCheck (StringRef Name, ClangTidyContext *Context)
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Implements C++ Core Guidelines Type.6.

Checks that every user-provided constructor value-initializes all class members and base classes that would have undefined behavior otherwise. Also check that any record types without user-provided default constructors are value-initialized where used.

Members initialized through function calls in the body of the constructor will result in false positives.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/cppcoreguidelines-pro-type-member-init.html TODO: See if 'fixes' for false positives are optimized away by the compiler. TODO: For classes with multiple constructors, make sure that we don't offer multiple in-class initializer fixits for the same member.

Definition at line 34 of file ProTypeMemberInitCheck.h.

## Constructor & Destructor Documentation

## ◆ ProTypeMemberInitCheck()

clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck::ProTypeMemberInitCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 249 of file ProTypeMemberInitCheck.cpp.

## Member Function Documentation

## ◆ check()

void clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 296 of file ProTypeMemberInitCheck.cpp.

## ◆ registerMatchers()

void clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 254 of file ProTypeMemberInitCheck.cpp.

## ◆ storeOptions()

void clang::tidy::cppcoreguidelines::ProTypeMemberInitCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 314 of file ProTypeMemberInitCheck.cpp.

References clang::tidy::ClangTidyCheck::Options, and clang::tidy::OptionsView::store().

The documentation for this class was generated from the following files:

- ProTypeMemberInitCheck.h
- ProTypeMemberInitCheck.cpp